VTK: vtkWebGPULight Class Reference

| VTK 9.3.1

Classes | Public Types | Public Member Functions | Static Public Member Functions | Protected Member Functions | Protected Attributes | List of all members
vtkWebGPULight Class Reference

OpenGL light. More...

`#include <vtkWebGPULight.h>`

Inheritance diagram for vtkWebGPULight:
[legend]
Collaboration diagram for vtkWebGPULight:
[legend]

## Classes
struct | LightInfo

## Public Types
typedef vtkLight | Superclass
Public Types inherited from vtkLight
typedef vtkObject | Superclass

## Public Member Functions
virtual vtkTypeBool | IsA (const char *type)
| Return 1 if this class is the same type of (or a subclass of) the named class. More...
vtkWebGPULight * | NewInstance () const
void | PrintSelf (ostream &os, vtkIndent indent) override
| Methods invoked by print to print information about the object including superclasses. More...
void | CacheLightInformation (vtkRenderer *renderer, vtkCamera *camera)
const void * | GetCachedLightInformation ()
void | Render (vtkRenderer *, int) override
| Abstract interface to renderer. More...
Public Member Functions inherited from vtkLight
vtkLight * | NewInstance () const
virtual vtkLight * | ShallowClone ()
| Create a new light object with the same light parameters than the current object (any ivar from the superclasses (vtkObject and vtkObjectBase), like reference counting, timestamp and observers are not copied). More...
void | TransformPoint (double a[3], double b[3])
| Use transform matrix to transform point (if it exists). More...
void | TransformVector (double a[3], double b[3])
| Use transform matrix to transform vector (if it exists). More...
void | DeepCopy (vtkLight *light)
| Perform deep copy of this light. More...
virtual void | SetAmbientColor (double, double, double)
| Set/Get the color of the light. More...
virtual void | SetAmbientColor (double[3])
| Set/Get the color of the light. More...
virtual double * | GetAmbientColor ()
| Set/Get the color of the light. More...
virtual void | GetAmbientColor (double data[3])
| Set/Get the color of the light. More...
virtual void | SetDiffuseColor (double, double, double)
| Set/Get the color of the light. More...
virtual void | SetDiffuseColor (double[3])
| Set/Get the color of the light. More...
virtual double * | GetDiffuseColor ()
| Set/Get the color of the light. More...
virtual void | GetDiffuseColor (double data[3])
| Set/Get the color of the light. More...
virtual void | SetSpecularColor (double, double, double)
| Set/Get the color of the light. More...
virtual void | SetSpecularColor (double[3])
| Set/Get the color of the light. More...
virtual double * | GetSpecularColor ()
| Set/Get the color of the light. More...
virtual void | GetSpecularColor (double data[3])
| Set/Get the color of the light. More...
void | SetColor (double, double, double)
| Set/Get the color of the light. More...
void | SetColor (const double a[3])
| Set/Get the color of the light. More...
virtual void | SetPosition (double, double, double)
| Set/Get the position of the light. More...
virtual void | SetPosition (double[3])
| Set/Get the position of the light. More...
virtual double * | GetPosition ()
| Set/Get the position of the light. More...
virtual void | GetPosition (double data[3])
| Set/Get the position of the light. More...
void | SetPosition (const float *a)
| Set/Get the position of the light. More...
virtual void | SetFocalPoint (double, double, double)
| Set/Get the point at which the light is shining. More...
virtual void | SetFocalPoint (double[3])
| Set/Get the point at which the light is shining. More...
virtual double * | GetFocalPoint ()
| Set/Get the point at which the light is shining. More...
virtual void | GetFocalPoint (double data[3])
| Set/Get the point at which the light is shining. More...
void | SetFocalPoint (const float *a)
| Set/Get the point at which the light is shining. More...
virtual void | SetIntensity (double)
| Set/Get the brightness of the light (from one to zero). More...
virtual double | GetIntensity ()
| Set/Get the brightness of the light (from one to zero). More...
virtual void | SetSwitch (vtkTypeBool)
| Turn the light on or off. More...
virtual vtkTypeBool | GetSwitch ()
| Turn the light on or off. More...
virtual void | SwitchOn ()
| Turn the light on or off. More...
virtual void | SwitchOff ()
| Turn the light on or off. More...
virtual void | SetPositional (vtkTypeBool)
| Turn positional lighting on or off. More...
virtual vtkTypeBool | GetPositional ()
| Turn positional lighting on or off. More...
virtual void | PositionalOn ()
| Turn positional lighting on or off. More...
virtual void | PositionalOff ()
| Turn positional lighting on or off. More...
virtual void | SetExponent (double)
| Set/Get the exponent of the cosine used in positional lighting. More...
virtual double | GetExponent ()
| Set/Get the exponent of the cosine used in positional lighting. More...
virtual void | SetConeAngle (double)
| Set/Get the lighting cone angle of a positional light in degrees. More...
virtual double | GetConeAngle ()
| Set/Get the lighting cone angle of a positional light in degrees. More...
virtual void | SetAttenuationValues (double, double, double)
| Set/Get the quadratic attenuation constants. More...
virtual void | SetAttenuationValues (double[3])
| Set/Get the quadratic attenuation constants. More...
virtual double * | GetAttenuationValues ()
| Set/Get the quadratic attenuation constants. More...
virtual void | GetAttenuationValues (double data[3])
| Set/Get the quadratic attenuation constants. More...
virtual void | SetTransformMatrix (vtkMatrix4x4 *)
| Set/Get the light's transformation matrix. More...
virtual vtkMatrix4x4 * | GetTransformMatrix ()
| Set/Get the light's transformation matrix. More...
void | GetTransformedPosition (double &x, double &y, double &z)
| Get the position of the light, modified by the transformation matrix (if it exists). More...
void | GetTransformedPosition (double a[3])
| Get the position of the light, modified by the transformation matrix (if it exists). More...
double * | GetTransformedPosition ()
| Get the position of the light, modified by the transformation matrix (if it exists). More...
void | GetTransformedFocalPoint (double &x, double &y, double &z)
| Get the focal point of the light, modified by the transformation matrix (if it exists). More...
void | GetTransformedFocalPoint (double a[3])
| Get the focal point of the light, modified by the transformation matrix (if it exists). More...
double * | GetTransformedFocalPoint ()
| Get the focal point of the light, modified by the transformation matrix (if it exists). More...
void | SetDirectionAngle (double elevation, double azimuth)
| Set the position and focal point of a light based on elevation and azimuth. More...
void | SetDirectionAngle (const double ang[2])
| Set the position and focal point of a light based on elevation and azimuth. More...
virtual void | SetLightType (int)
| Set/Get the type of the light. More...
virtual int | GetLightType ()
| Set/Get the type of the light. More...
void | SetLightTypeToHeadlight ()
| Set/Get the type of the light. More...
void | SetLightTypeToSceneLight ()
| Set/Get the type of the light. More...
void | SetLightTypeToCameraLight ()
| Set/Get the type of the light. More...
int | LightTypeIsHeadlight ()
| Query the type of the light. More...
int | LightTypeIsSceneLight ()
| Query the type of the light. More...
int | LightTypeIsCameraLight ()
| Query the type of the light. More...
virtual void | SetShadowAttenuation (float)
| Set/Get the shadow intensity By default a light will be completely blocked when in shadow by setting this value to less than 1.0 you can control how much light is attenuated when in shadow. More...
virtual float | GetShadowAttenuation ()
| Set/Get the shadow intensity By default a light will be completely blocked when in shadow by setting this value to less than 1.0 you can control how much light is attenuated when in shadow. More...
virtual vtkInformation * | GetInformation ()
| Set/Get the information object associated with the light. More...
virtual void | SetInformation (vtkInformation *)
| Set/Get the information object associated with the light. More...
Public Member Functions inherited from vtkObject
| vtkBaseTypeMacro (vtkObject, vtkObjectBase)
virtual void | DebugOn ()
| Turn debugging output on. More...
virtual void | DebugOff ()
| Turn debugging output off. More...
bool | GetDebug ()
| Get the value of the debug flag. More...
void | SetDebug (bool debugFlag)
| Set the value of the debug flag. More...
virtual void | Modified ()
| Update the modification time for this object. More...
virtual vtkMTimeType | GetMTime ()
| Return this object's modified time. More...
void | RemoveObserver (unsigned long tag)
void | RemoveObservers (unsigned long event)
void | RemoveObservers (const char *event)
void | RemoveAllObservers ()
vtkTypeBool | HasObserver (unsigned long event)
vtkTypeBool | HasObserver (const char *event)
vtkTypeBool | InvokeEvent (unsigned long event)
vtkTypeBool | InvokeEvent (const char *event)
std::string | GetObjectDescription () const override
| The object description printed in messages and PrintSelf output. More...
unsigned long | AddObserver (unsigned long event, vtkCommand *, float priority=0.0f)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
unsigned long | AddObserver (const char *event, vtkCommand *, float priority=0.0f)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
vtkCommand * | GetCommand (unsigned long tag)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
void | RemoveObserver (vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
void | RemoveObservers (unsigned long event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
void | RemoveObservers (const char *event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
vtkTypeBool | HasObserver (unsigned long event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
vtkTypeBool | HasObserver (const char *event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, void(T::*callback)(), float priority=0.0f)
| Overloads to AddObserver that allow developers to add class member functions as callbacks for events. More...
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, void(T::*callback)(vtkObject *, unsigned long, void *), float priority=0.0f)
| Overloads to AddObserver that allow developers to add class member functions as callbacks for events. More...
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, bool(T::*callback)(vtkObject *, unsigned long, void *), float priority=0.0f)
| Allow user to set the AbortFlagOn() with the return value of the callback method. More...
vtkTypeBool | InvokeEvent (unsigned long event, void *callData)
| This method invokes an event and return whether the event was aborted or not. More...
vtkTypeBool | InvokeEvent (const char *event, void *callData)
| This method invokes an event and return whether the event was aborted or not. More...
virtual void | SetObjectName (const std::string &objectName)
| Set/get the name of this object for reporting purposes. More...
virtual std::string | GetObjectName () const
| Set/get the name of this object for reporting purposes. More...
Public Member Functions inherited from vtkObjectBase
const char * | GetClassName () const
| Return the class name as a string. More...
virtual vtkIdType | GetNumberOfGenerationsFromBase (const char *name)
| Given the name of a base class of this class type, return the distance of inheritance between this class type and the named class (how many generations of inheritance are there between this class and the named class). More...
virtual void | Delete ()
| Delete a VTK object. More...
virtual void | FastDelete ()
| Delete a reference to this object. More...
void | InitializeObjectBase ()
void | Print (ostream &os)
| Print an object to an ostream. More...
virtual void | Register (vtkObjectBase *o)
| Increase the reference count (mark as used by another object). More...
virtual void | UnRegister (vtkObjectBase *o)
| Decrease the reference count (release by another object). More...
int | GetReferenceCount ()
| Return the current reference count of this object. More...
void | SetReferenceCount (int)
| Sets the reference count. More...
bool | GetIsInMemkind () const
| A local state flag that remembers whether this object lives in the normal or extended memory space. More...
virtual void | PrintHeader (ostream &os, vtkIndent indent)
| Methods invoked by print to print information about the object including superclasses. More...
virtual void | PrintTrailer (ostream &os, vtkIndent indent)
| Methods invoked by print to print information about the object including superclasses. More...
virtual bool | UsesGarbageCollector () const
| Indicate whether the class uses `vtkGarbageCollector` or not. More...

## Static Public Member Functions
static vtkWebGPULight * | New ()
static vtkTypeBool | IsTypeOf (const char *type)
static vtkWebGPULight * | SafeDownCast (vtkObjectBase *o)
static std::size_t | GetCacheSizeBytes ()
Static Public Member Functions inherited from vtkLight
static vtkTypeBool | IsTypeOf (const char *type)
static vtkLight * | SafeDownCast (vtkObjectBase *o)
static vtkLight * | New ()
| Create a light with the focal point at the origin and its position set to (0,0,1). More...
Static Public Member Functions inherited from vtkObject
static vtkObject * | New ()
| Create an object with Debug turned off, modified time initialized to zero, and reference counting on. More...
static void | BreakOnError ()
| This method is called when vtkErrorMacro executes. More...
static void | SetGlobalWarningDisplay (vtkTypeBool val)
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
static void | GlobalWarningDisplayOn ()
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
static void | GlobalWarningDisplayOff ()
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
static vtkTypeBool | GetGlobalWarningDisplay ()
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
Static Public Member Functions inherited from vtkObjectBase
static vtkTypeBool | IsTypeOf (const char *name)
| Return 1 if this class type is the same type of (or a subclass of) the named class. More...
static vtkIdType | GetNumberOfGenerationsFromBaseType (const char *name)
| Given a the name of a base class of this class type, return the distance of inheritance between this class type and the named class (how many generations of inheritance are there between this class and the named class). More...
static vtkObjectBase * | New ()
| Create an object with Debug turned off, modified time initialized to zero, and reference counting on. More...
static void | SetMemkindDirectory (const char *directoryname)
| The name of a directory, ideally mounted -o dax, to memory map an extended memory space within. More...
static bool | GetUsingMemkind ()
| A global state flag that controls whether vtkObjects are constructed in the usual way (the default) or within the extended memory space. More...

## Protected Member Functions
virtual vtkObjectBase * | NewInstanceInternal () const
| vtkWebGPULight ()=default
| ~vtkWebGPULight () override=default
Protected Member Functions inherited from vtkLight
| vtkLight ()
| ~vtkLight () override
Protected Member Functions inherited from vtkObject
| vtkObject ()
| ~vtkObject () override
void | RegisterInternal (vtkObjectBase *, vtkTypeBool check) override
void | UnRegisterInternal (vtkObjectBase *, vtkTypeBool check) override
void | InternalGrabFocus (vtkCommand *mouseEvents, vtkCommand *keypressEvents=nullptr)
| These methods allow a command to exclusively grab all events. More...
void | InternalReleaseFocus ()
| These methods allow a command to exclusively grab all events. More...
Protected Member Functions inherited from vtkObjectBase
| vtkObjectBase ()
virtual | ~vtkObjectBase ()
virtual void | ReportReferences (vtkGarbageCollector *)
| vtkObjectBase (const vtkObjectBase &)
void | operator= (const vtkObjectBase &)

## Protected Attributes
LightInfo | CachedLightInfo
Protected Attributes inherited from vtkLight
double | FocalPoint [3]
double | Position [3]
double | Intensity
double | AmbientColor [3]
double | DiffuseColor [3]
double | SpecularColor [3]
vtkTypeBool | Switch
vtkTypeBool | Positional
double | Exponent
double | ConeAngle
double | AttenuationValues [3]
vtkMatrix4x4 * | TransformMatrix
double | TransformedFocalPointReturn [3]
double | TransformedPositionReturn [3]
int | LightType
float | ShadowAttenuation
vtkInformation * | Information
Protected Attributes inherited from vtkObject
bool | Debug
vtkTimeStamp | MTime
vtkSubjectHelper * | SubjectHelper
std::string | ObjectName
Protected Attributes inherited from vtkObjectBase
std::atomic< int32_t > | ReferenceCount
vtkWeakPointerBase ** | WeakPointers

## Additional Inherited Members
Static Protected Member Functions inherited from vtkObjectBase
static vtkMallocingFunction | GetCurrentMallocFunction ()
static vtkReallocingFunction | GetCurrentReallocFunction ()
static vtkFreeingFunction | GetCurrentFreeFunction ()
static vtkFreeingFunction | GetAlternateFreeFunction ()

## Detailed Description

OpenGL light.

vtkWebGPULight is a concrete implementation of the abstract class vtkLight. vtkWebGPULight interfaces to the OpenGL rendering library.

Definition at line 22 of file vtkWebGPULight.h.

## Member Typedef Documentation

## ◆ Superclass

typedef vtkLight vtkWebGPULight::Superclass

Definition at line 26 of file vtkWebGPULight.h.

## Constructor & Destructor Documentation

## ◆ vtkWebGPULight()

vtkWebGPULight::vtkWebGPULight | ( |  | ) |
| protecteddefault

## ◆ ~vtkWebGPULight()

vtkWebGPULight::~vtkWebGPULight | ( |  | ) |
| overrideprotecteddefault

## Member Function Documentation

## ◆ New()

static vtkWebGPULight* vtkWebGPULight::New | ( |  | ) |
| static

## ◆ IsTypeOf()

static vtkTypeBool vtkWebGPULight::IsTypeOf | ( | const char * | type | ) |
| static

## ◆ IsA()

virtual vtkTypeBool vtkWebGPULight::IsA | ( | const char * | name | ) |
| virtual

Return 1 if this class is the same type of (or a subclass of) the named class.

Returns 0 otherwise. This method works in combination with vtkTypeMacro found in vtkSetGet.h.

Reimplemented from vtkLight.

## ◆ SafeDownCast()

static vtkWebGPULight* vtkWebGPULight::SafeDownCast | ( | vtkObjectBase * | o | ) |
| static

## ◆ NewInstanceInternal()

virtual vtkObjectBase* vtkWebGPULight::NewInstanceInternal | ( |  | ) | const
| protectedvirtual

Reimplemented from vtkLight.

## ◆ NewInstance()

vtkWebGPULight* vtkWebGPULight::NewInstance | ( |  | ) | const

## ◆ PrintSelf()

void vtkWebGPULight::PrintSelf | ( | ostream & | os,
|  | vtkIndent | indent
| ) |  |
| overridevirtual

Methods invoked by print to print information about the object including superclasses.

Typically not called by the user (use Print() instead) but used in the hierarchical print process to combine the output of several classes.

Reimplemented from vtkLight.

## ◆ CacheLightInformation()

void vtkWebGPULight::CacheLightInformation | ( | vtkRenderer * | renderer,
|  | vtkCamera * | camera
| ) |  |

## ◆ GetCachedLightInformation()

const void* vtkWebGPULight::GetCachedLightInformation | ( |  | ) |
| inline

Definition at line 30 of file vtkWebGPULight.h.

## ◆ GetCacheSizeBytes()

static std::size_t vtkWebGPULight::GetCacheSizeBytes | ( |  | ) |
| inlinestatic

Definition at line 31 of file vtkWebGPULight.h.

## ◆ Render()

void vtkWebGPULight::Render | ( | vtkRenderer * | ,
|  | int |
| ) |  |
| overridevirtual

Abstract interface to renderer.

Each concrete subclass of vtkLight will load its data into the graphics system in response to this method invocation. The actual loading is performed by a vtkLightDevice subclass, which will get created automatically.

Reimplemented from vtkLight.

## Member Data Documentation

## ◆ CachedLightInfo

LightInfo vtkWebGPULight::CachedLightInfo
| protected

Definition at line 54 of file vtkWebGPULight.h.

The documentation for this class was generated from the following file:

- Rendering/WebGPU/vtkWebGPULight.h